#!/bin/bash

# 0.check the system and bbr

# 检查 OS 的版本号
OS_VERSION="0"
if grep -Eqi "release 4\." /etc/redhat-release ; then
	#OS_VERSION="4"
	echo Sorry , BBR does not support CentOS Liunx 4.x
	exit
elif grep -Eqi "release 5\." /etc/redhat-release ; then
    #OS_VERSION="5"
	echo Sorry , BBR does not support CentOS Liunx 5.x
	exit
elif grep -Eqi "release 6\." /etc/redhat-release ; then
    OS_VERSION="6"
elif grep -Eqi "release 7\." /etc/redhat-release ; then
    OS_VERSION="7"
else
	echo Sorry , The current system is unknown .	
	exit
fi

# 检查是否已经安装了 BBR
if lsmod | grep -Eqi "bbr" ; then
    echo The server already installed BBR .
    exit
fi

# 1.check network ，检查是否可以访问互联网
CHANGE_FLAG="0"
CODE=`curl -I -m 30 -o /dev/null -s -w %{http_code} http://www.baidu.com`
if [ "$CODE" != "200" ] ; then
	# 如果不可以访问互联网，就去 192.168.1.1 上开启 IP 路由转发和 NAT ，然后把 192.168.1.1 当做这台服务器的网关
	echo "WARNING ！接下来要做 NAT ，请不要同时在多台服务器上同时跑这个脚本！因为当某台服务器安装完 BBR 后会去清理掉 NAT ，其他服务器将无法通过 NAT 继续访问互联网。 "
	read -p "Presses Y to continue , presses E to exit ..." IS_CONTINUE
	if [ "$IS_CONTINUE" != "Y" -a "$IS_CONTINUE" != "y" ] ; then
        exit
    fi
    CHANGE_FLAG="1"

	# 选择内网网卡，好往这个网卡的配置文件里添加一行网关的配置（ GATEWAY=192.168.1.1 ），然后重启网络服务让配置生效，这样服务器就可以通过 192.168.1.1 访问互联网了。
    echo network-scripts list :
    ls /etc/sysconfig/network-scripts/ | grep ifcfg-

    NETWORK_CONFIG_DIR="/etc/sysconfig/network-scripts/"
    NETWORK_CONFIG_NAME="NULL"
    while [ ! -f "$NETWORK_CONFIG_DIR$NETWORK_CONFIG_NAME" ] ; do
        read -p "Please input the private network config name (eg:ifcfg-eth1) : " NETWORK_CONFIG_NAME
    done

	cp -f $NETWORK_CONFIG_DIR$NETWORK_CONFIG_NAME /tmp/network_config.bak

	echo
	echo 'please input the root password:123456'
	# 此处 eth0 需要是能够访问外部网络的网卡接口
	ssh -t root@192.168.1.1 'iptables -t nat -F && iptables -P FORWARD ACCEPT && iptables -t nat -A POSTROUTING -o eth0 -j MASQUERADE && echo "1" > /proc/sys/net/ipv4/ip_forward'

	sed -i "/GATEWAY=/d" $NETWORK_CONFIG_DIR$NETWORK_CONFIG_NAME
	echo "GATEWAY=192.168.1.1" >> $NETWORK_CONFIG_DIR$NETWORK_CONFIG_NAME
	service network restart
fi


CODE=`curl -I -m 30 -o /dev/null -s -w %{http_code} http://www.baidu.com`
if [ "$CODE" == "200" ] ; then

# 2.install BBR ，安装 BBR

	if [ "$OS_VERSION" = "6" ] ; then
		echo
		echo The Server running CentOS Linux 6.x
		echo
                
        # 如果不升级 nss 的话，在访问一些 https 站点时可能会报错
        yum install -y nss wget
		yum update -y nss wget

        # 注意：kernel-ml（ ml 是 mainline 的缩写）目前已经升级至 5.x ，
        # 可能因为 CentOS 6 不支持 5.x 的 kernel ，所以 yum 源里 CentOS 6 的 kernel-ml 已经被移除不能安装了，
        # 目前仅能安装版本为 4.4.x 的 kernel-lt（ lt 是 longterm 的缩写）。2019 年 5 月 9 日 22:11:31 。
		#rpm --import https://www.elrepo.org/RPM-GPG-KEY-elrepo.org
        #rpm -Uvh http://www.elrepo.org/elrepo-release-6-8.el6.elrepo.noarch.rpm
		#yum --enablerepo=elrepo-kernel -y install kernel-ml kernel-ml-devel

        # 因为使用上述 yum 源无法安装 kernel-ml ，所以使用下列 rpm 包进行安装。2019 年 5 月 9 日 22:11:31 。
		if [ $(getconf WORD_BIT) = '32' ] && [ $(getconf LONG_BIT) = '64' ]; then
            wget https://pan.ccie.lol:44944/file/Linux/CentOS/6/rpm/kernel-ml-4.18.20-1.el6.elrepo.x86_64.rpm -P /tmp/
            wget https://pan.ccie.lol:44944/file/Linux/CentOS/6/rpm/kernel-ml-devel-4.18.20-1.el6.elrepo.x86_64.rpm -P /tmp/
            rpm -ivh /tmp/kernel-ml-devel-4.18.20-1.el6.elrepo.x86_64.rpm
            rpm -ivh /tmp/kernel-ml-4.18.20-1.el6.elrepo.x86_64.rpm
            rm -f /tmp/kernel-ml-devel-4.18.20-1.el6.elrepo.x86_64.rpm /tmp/kernel-ml-4.18.20-1.el6.elrepo.x86_64.rpm
        else
            wget https://pan.ccie.lol:44944/file/Linux/CentOS/6/rpm/kernel-ml-4.18.20-1.el6.elrepo.i686.rpm -P /tmp/
            wget https://pan.ccie.lol:44944/file/Linux/CentOS/6/rpm/kernel-ml-devel-4.18.20-1.el6.elrepo.i686.rpm -P /tmp/
            rpm -ivh /tmp/kernel-ml-devel-4.18.20-1.el6.elrepo.i686.rpm
            rpm -ivh /tmp/kernel-ml-4.18.20-1.el6.elrepo.i686.rpm
            rm -f /tmp/kernel-ml-devel-4.18.20-1.el6.elrepo.i686.rpm /tmp/kernel-ml-4.18.20-1.el6.elrepo.i686.rpm
        fi

		sed -i 's/^default=.*/default=0/g' /boot/grub/grub.conf
		sed -i '/net.core.default_qdisc/d' /etc/sysctl.conf
		sed -i '/net.ipv4.tcp_congestion_control/d' /etc/sysctl.conf

		echo "net.core.default_qdisc = fq" >> /etc/sysctl.conf
		echo "net.ipv4.tcp_congestion_control = bbr" >> /etc/sysctl.conf
		
	elif [ "$OS_VERSION" = "7" ] ; then
		echo
		echo The Server running CentOS Linux 7.x
		echo

		rpm --import https://www.elrepo.org/RPM-GPG-KEY-elrepo.org
		rpm -Uvh http://www.elrepo.org/elrepo-release-7.0-3.el7.elrepo.noarch.rpm
		yum --enablerepo=elrepo-kernel install kernel-ml kernel-ml-devel -y
		
		egrep ^menuentry /etc/grub2.cfg | cut -f 2 -d \'
		grub2-set-default 0

		echo "net.core.default_qdisc = fq" >> /etc/sysctl.conf
		echo "net.ipv4.tcp_congestion_control = bbr" >> /etc/sysctl.conf
	fi
else
	# 网络还是不通
	echo Sorry ! Network connection failure , please check it !
fi

# 3.clear the network config ，清理相关网络配置，恢复原样
if [ "$CHANGE_FLAG" == "1" ] ; then
	echo
	echo 'please input the root password:123456'
	ssh -t root@192.168.1.1 'iptables -t nat -F && echo "0" > /proc/sys/net/ipv4/ip_forward'

	mv -f /tmp/network_config.bak $NETWORK_CONFIG_DIR$NETWORK_CONFIG_NAME
	service network restart

	# 这个 yum 源需要通过互联网才能访问到，如果内网机器平常不会连接互联网，那么最好改下这个文件名，防止这个 yum 源生效
    if [ -f "/etc/yum.repos.d/elrepo.repo" ] ; then
	    mv /etc/yum.repos.d/elrepo.repo /etc/yum.repos.d/elrepo.repo_bak
    fi
fi

# 4.hint ，安装完 BBR 并重新启动服务器后，可使用下列命令来查看 BBR 是否安装成功
echo
echo '==========================

Check the BBR command :

cat /etc/redhat-release
uname -r
lsmod | grep bbr
sysctl net.ipv4.tcp_available_congestion_control

=========================='

# 5.reboot the server ，重启服务器
echo
read -p "Presses Y to reboot system ..."  IS_REBOOT
if [ "$IS_REBOOT" == "Y" -o "$IS_REBOOT" == "y" ] ; then
	reboot
fi